# Flux Pulumi Provider

The Flux Provider lets you manage [FluxCD](https://fluxcd.io) resources.
This provider wraps the existing [Terraform Provider Flux](https://github.com/fluxcd/terraform-provider-flux).

## Installing

This package is available for several languages/platforms:

### Node.js (JavaScript/TypeScript)

To use from JavaScript or TypeScript in Node.js, install using either `npm`:

```bash
npm install @worawat/flux
```

or `yarn`:

```bash
yarn add @worawat/flux
```

### Python

To use from Python, install using `pip`:

```bash
pip install pulumi-flux
```

### Go

To use from Go, use `go get` to grab the latest version of the library:

```bash
go get github.com/oun/pulumi-flux/sdk/go/...
```

### .NET

To use from .NET, install using `dotnet add package`:

```bash
dotnet add package Pulumi.Flux
```

## Examples

Find working Python code samples in the [`./examples`](https://github.com/oun/pulumi-flux/tree/main/examples) directory.

## Reference

For detailed reference documentation, please visit the [the Pulumi registry](https://www.pulumi.com/registry/packages/flux/api-docs/).
